import { Api } from './api';
import { Auth } from './auth';
import { ClientConfig, ClientType, NexusConfig } from './common';
import { Module } from './module';
import { Multitool } from './multitool';
import { ClientAuth, SystemInstance, SystemLoggerOptions } from './system';
export { Api, Auth, Module, ClientType, ClientAuth, ClientConfig, NexusConfig, SystemInstance };
export declare type ConfigSettings = {
    nexus: NexusConfig;
    client: ClientConfig;
    auth: ClientAuth;
    logging: SystemLoggerOptions;
};
export interface BfLib {
    api: Api;
    auth: Auth;
    module: Module;
    multitool: Multitool;
}
export default function bflib(settings: ConfigSettings): Promise<BfLib>;
